package checkers.util.test;

import java.lang.annotation.*;

import static java.lang.annotation.ElementType.*;

import com.sun.source.tree.Tree;

import checkers.quals.ImplicitFor;
import checkers.quals.SubtypeOf;
import checkers.quals.TypeQualifier;
import checkers.quals.Unqualified;


/**
 * Example from Adam Warski.
 * The Checker Framework should issue an error message of some sort,
 * because the code is malformed:
 * it should use @SubtypeOf({Unqualified.java}) rather than
 * @SubtypeOf({}).  (In a previous version of the Checker Framework, this
 * code exposed a bug:  WarskiQualChecker, which processes this qualifier,
 * crashed.
 **/

@TypeQualifier
@SubtypeOf({})
@ImplicitFor
@Retention(RetentionPolicy.RUNTIME)
@Target({FIELD, LOCAL_VARIABLE, METHOD, PARAMETER, TYPE})
public @interface WarskiQual {
}
